This chapter provide an introduction to the concepts and terminology of Ethernet protocol stack, in particular the IP protocol, TCP and UDP communications, related to FreeRTOS+TCP extension library.  

Take in consideration that you don't need to understand in deep all of these network protocol concepts, because FreeRTOS+TCP takes care of implementing the protocols. If you want to dive in the implementation of FreeRTOS+TCP, you certainly need to know really well the topics discussed in this chapter, but if you need only to use it as a protocol stack library you only need to know enough to understand the FreeRTOS+TCP configuration options, and how to use the standard socket interface to send and receive data.

The following concepts provides the basis to understand and setup properly the \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_TCP/TCP_IP_Configuration.html}{FreeRTOS+TCP configuration options} of your embedded device FreeRTOS-based application. All the FreeRTOS+TCP configuration settings can be found in \textit{FreeRTOSIPConfig.h} file.

\begin{itemize}
	\item \textbf{Ethernet frames}: the data link layer packet data unit, that uses the underlying Ethernet physical layer mechanism.
	\item \textbf{MAC address}: different nodes on the same Ethernet network are identified in the Ethernet frames by their MAC address, unique for each node on a local Ethernet network and normally written as 6 octets (8-bit values) separated by a colon.
	\item \textbf{IP}: the Internet Protocol is the protocol used to communicate across networks (inter-networking), such as on the Internet. Nodes on an IP network are identified by their IP address. 
	\item \textbf{ARP}: The Address Resolution Protocol is used to obtain MAC address information. IP packets are sent between IP addresses, but the Ethernet frames in which they are packaged are sent between MAC addresses. Therefore the MAC address of the destination IP address must be known before an IP packet can be sent onto an Ethernet network. ARP broadcast packets must be sent to retrieve the MAC address of a destination IP address and the IP address MAC address mappings is then stored in an ARP table. 
	\item \textbf{UDP}: User Datagram Protocol is a transport layer protocol carried by an IP packet. The UDP protocol doesn't include a means of knowing if transmitted data ever reached its intended recipient. If such an acknowledgement is required then it must be provided by the application itself or using TCP. UDP packets are considered connectionless because, unlike TCP packets, they do not need to establish a connection to another network node before they can send or receive data. UDP is much faster, simpler, and requires less RAM than TCP.
	\item \textbf{TCP}: Transmission Control Protocol is a transport layer protocol carried by a IP packet and it's used to send and receive a stream of data on a pre-established connection. The TCP protocol itself takes care of setting up the connection, and ensuring that all transmitted data is received correctly. TCP is more reliable than UDP, but is more complex to use and requires more RAM.
	\item \textbf{Port Number}: the source and destination address of each TCP or UDP packet is therefore a combination of an IP address and a port number. The IP address identifies the node on the network and the port number identifies the application within the node.
	\item \textbf{Network Socket}: a socket is identified using the IP address of the network node, and the port number within the network node. A network node that wants to send or receive UDP data has only to open a socket, without establishing a connection. Otherwise if it wants to use TCP, it creates the socket and then if it wants to send a packet it has to wait that connection socket to socked is established, otherwise if it wants to receive data it has to listen for incoming socket connections. FreeRTOS+TCP uses the standard \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_TCP/API/socket.html}{\texttt{FreeRTOS\_socket()}} function to create a socket.
	\item \textbf{Binding}: a socket that has both an IP address and a port number it is said to be \textit{bound to a port}, if a socket has only an IP address it is said to be \textit{unbound} and it cannot receive data. The process of allocating a port number to a socket is called \textit{binding} and FreeRTOS+TCP uses \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_TCP/API/bind.html}{\texttt{FreeRTOS\_bind()}} to do it.
	\item \textbf{MTU}: the Maximum Transmission Unit is usually depending on the characteristic of physical layer. MTU is the size of the largest protocol data unit (PDU) that can be communicated in a single network layer transaction. Larger MTU is associated with reduced overhead. Smaller MTU values can reduce network delay. If the application sends a block of data that is larger than the MTU size the data will be split into multiple packet frame. In FreeRTOS+TCP you can configure the MTU size in the \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_TCP/TCP_IP_Configuration.html#ipconfigNETWORK_MTU}{\texttt{ipconfigNETWORK\_MTU}} define, specified in bytes. 
	\item \textbf{MSS}: the Maximum Segment Size defines the maximum amount of data that can be sent or received in a network excluding all the protocols header. The MSS is dependent on the MTU. In FreeRTOS+TCP the MSS value is set by the \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_TCP/TCP_IP_Configuration.html#ipconfigTCP_MSS}{\texttt{ipconfigTCP\_MSS}} define, in number of bytes.
	\item \textbf{Subnet and Routing}: the Netmask is an address with the most significant part composed only by 1, and the other with 0, used to provide the routing information. The Subnetmask is the Netmask bitwise negation and it provides local address information. The Netmask and Subnetmask addresses are used to identify if a destination address exist in the internal network, otherwise the packet must be sent to a router for internet routing.
	\item \textbf{Gateway}: the IP address of the router. FreeRTOS+TCP needs a gateway address or can be configured dynamically from a DHCP server. 
	\item \textbf{Client and Server}: Clients are applications that actively connect to remote applications in order to obtain a service from it. The remote application is the Server, that waits for and then replies to incoming requests from clients. Servers do not need to know the client’s address or port in advance, they just send their replies to the address and port from which the client’s request originated.
	\item \textbf{Static IP}: IP address preassigned and never changed. The FreeRTOS+TCP function \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_TCP/API/FreeRTOS_IPInit.html}{\texttt{FreeRTOS\_IPInit()}} takes a default IP address that is used if DHCP is disabled or if DHCP server failed to be contacted. Static IP addresses are impractical for product deployment for embedded system because the static IP has to be hardcoded and we will no longer able to edit. 
	\item \textbf{DHCP}: Dynamic Host Control Protocol provides an alternative to static IP address assignment with a DHCP server on local networks that dynamically allocate IP addresses to nodes on the same network. If \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_TCP/TCP_IP_Configuration.html#ipconfigUSE_DHCP}{\texttt{ipconfigUSE\_DHCP}} is set to 1 then FreeRTOS+TCP will attempt to obtain its IP address from a DHCP server.
	\item \textbf{Name resolution}: the process of converting a human readable name into an IP address.
	\item \textbf{DNS}: the Domain Name System is a form of domain name resolution. It maps static and easily human readable textual names to IP addresses. DNS is enabled in FreeRTOS+TCP with \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_TCP/TCP_IP_Configuration.html#ipconfigUSE_DNS}{\texttt{ipconfigUSE\_DNS}} is set to 1.
	\item \textbf{LLMNR}: the Link Local Multicast Name Resolution is a protocol for name resolution used by all major web browsers to resolve names that do not include the domain suffix (\textit{.it}, \textit{.net}, \textit{.eu}...). In FreeRTOS+TCP the network interface must be programmed to accept packets on \texttt{224.0.0.252} address for LLMNR to work,  \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_TCP/TCP_IP_Configuration.html#ipconfigUSE_LLMNR}{\texttt{ipconfigUSE\_LLMNR}} must be 1 and \texttt{xApplicationDNSQueryHook()} callback must be implemented.
	\item \textbf{NBNS}: the NetBIO Name Service is a protocol for name resolution and performs the same function as LLMNR, but using UDP broadcast packets instead of multi cast packets. The \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_TCP/TCP_IP_Configuration.html#ipconfigUSE_LLMNR}{\texttt{ipconfigUSE\_NBNS}} must be set to 1 and \texttt{xApplicationDNSQueryHook()} callback must be implemented.
	\item \textbf{Little Endian, Big Endian}: microcontrollers that store the most significant byte first are called big endian, the ones that store the least significant byte first are called little endian. Talking about embedded network system there is no guarantees that all the embedded system on the connected network will have the same byte order. FreeRTOS+TCP sends package in big endian order, therefore if the device is little endian, the data has to be read in reverse order. This operation is already managed in FreeRTOS+TCP library, so the developer doesn't need to swap data manually.
\end{itemize} 